;Author: Qu
;Last Modified: 4/20/2011
;Version: 1.0. First public release
;Check out http://www.atitd.org/wiki/tale5/Qu/Macros/Mining for the readme.

;Gem Reference:
;
;Alcyone	Topaz
;Celeano	Emerald
;Maia		Ruby
;Merope		Sapphire
;Sterope	Quartz
;Taygete	Opal
;Sinai		Diamond

#NoEnv
#SingleInstance, Force
SendMode Input
SetWorkingDir %A_ScriptDir%
SetDefaultMouseSpeed, 0
CoordMode, Mouse, Relative

;CONFIGUARION

;Set DefaultDelay high if you're getting popups about stones being busy. 
;This is caused by lag spikes in the game and there isn't a way to work around it
;other than to slow down the macro.
;When there are few players and no devs on I could set this to as low as 100
;and still have the macro work reliably.

DefaultDelay:=250 ;How long the macro waits between actions

BreakDelay:=1000  ;How long the macro pauses after breaking stones
PopupDelay:=300   ;Not really important

;Zeroes out starting variables
Loop, 7
  Color%A_Index%:=0
MineSet:=0
Stones:=0
ConsecutiveRuns:=0
AdjustSpeed:=0

Start:=0

^e::
SendInput, %Start%
SendInput, {Enter}
Start+=2
return

;Sets up mine position
^`::
MouseGetPos, MouseX, MouseY
MineX:=MouseX
MineY:=MouseY
MineSet:=1
return

^1::
Stones++
MouseGetPos, MouseX, MouseY
StoneX%Stones%:=MouseX
StoneY%Stones%:=MouseY
Color1++
If Stones = 7
  gosub mine
return

^2::
Stones++
MouseGetPos, MouseX, MouseY
StoneX%Stones%:=MouseX
StoneY%Stones%:=MouseY
Color2++
If Stones = 7
  gosub mine
return

^3::
Stones++
MouseGetPos, MouseX, MouseY
StoneX%Stones%:=MouseX
StoneY%Stones%:=MouseY
Color3++
If Stones = 7
  gosub mine
return

^4::
Stones++
MouseGetPos, MouseX, MouseY
StoneX%Stones%:=MouseX
StoneY%Stones%:=MouseY
Color4++
If Stones = 7
  gosub mine
return

^5::
Stones++
MouseGetPos, MouseX, MouseY
StoneX%Stones%:=MouseX
StoneY%Stones%:=MouseY
Color5++
If Stones = 7
  gosub mine
return

^6::
Stones++
MouseGetPos, MouseX, MouseY
StoneX%Stones%:=MouseX
StoneY%Stones%:=MouseY
Color6++
If Stones = 7
  gosub mine
return

^7::
Stones++
MouseGetPos, MouseX, MouseY
StoneX%Stones%:=MouseX
StoneY%Stones%:=MouseY
Color7++
If Stones = 7
  gosub mine
return

mine:
BlockInput, MouseMove
;First determine the pattern
If (Color1=1 && Color2=1 && Color3=1 && Color4=1 && Color5=1 && Color6=1 && Color7=1)
{
  ;Seven colors
  ;Breaks all seven stones at the same time

  WorkPattern(1,1,1,1,1,1,0)
  WorkPattern(1,1,1,1,1,0,1)
  WorkPattern(1,1,1,1,0,1,1)
  WorkPattern(1,1,1,0,1,1,1)
  WorkPattern(1,1,0,1,1,1,1)
  WorkPattern(1,0,1,1,1,1,1)
  WorkPattern(0,1,1,1,1,1,1)
  WorkPattern(1,1,1,1,1,1,1)
}
Else If (Color1=2 && Color2=1 && Color3=1 && Color4=1 && Color5=1 && Color6=1 && Color7=0)
{
  ;One pair (six colors)
  ;Breaks all stones

  WorkPattern(1,0,1,1,0,0,0)
  WorkPattern(0,1,0,0,1,1,0)
  WorkPattern(1,0,0,0,1,1,1)
  WorkPattern(0,1,1,1,0,0,0)
  WorkPattern(1,0,1,0,1,0,0)
  WorkPattern(0,1,0,0,0,1,1)
  WorkPattern(1,0,0,1,0,1,1)
  Sleep, 50
  WorkPattern(0,1,0,1,1,0,0)
  WorkPattern(1,0,1,0,0,1,0)
  WorkPattern(0,1,0,1,1,1,0)
  WorkPattern(1,0,0,1,1,0,1)
  WorkPattern(0,1,1,0,0,0,1)
  WorkPattern(1,0,1,0,1,0,1)
  Sleep, BreakDelay
  WorkPattern(0,1,1,1,1,1,1)
}
Else If (Color1=2 && Color2=2 && Color3=1 && Color4=1 && Color5=1 && Color6=0 && Color7=0)
{
  ;Two pairs, five colors
  ;Breaks all stones

  WorkPattern(0,0,0,0,1,1,1)
  WorkPattern(1,0,1,0,1,0,0)
  WorkPattern(0,1,1,0,1,0,0)
  WorkPattern(1,0,0,1,1,0,0)
  WorkPattern(0,1,0,1,1,0,0)
  WorkPattern(1,0,1,0,0,1,0)
  WorkPattern(0,1,1,0,0,1,0)
  WorkPattern(1,0,0,1,0,1,0)
  WorkPattern(0,1,0,1,0,1,0)
  WorkPattern(1,0,1,0,0,0,1)
  WorkPattern(0,1,1,0,0,0,1)
  WorkPattern(1,0,0,1,0,0,1)
  WorkPattern(0,1,0,1,0,0,1)
  WorkPattern(1,0,1,0,1,1,1)
  Sleep, BreakDelay
  WorkPattern(0,1,0,1,1,1,1)
}
Else If (Color1=2 && Color2=2 && Color3=2 && Color4=1 && Color5=0 && Color6=0 && Color7=0)
{
  ;Three pairs (4 colors)
  ;Breaks all stones

  WorkPattern(1,0,1,0,1,0,0)
  WorkPattern(0,1,0,1,0,1,1)
  WorkPattern(1,0,1,0,0,1,0)
  WorkPattern(0,1,0,1,1,0,1)
  WorkPattern(1,0,0,1,1,0,0)
  WorkPattern(0,1,1,0,0,1,1)
  WorkPattern(1,0,0,1,0,1,0)
  WorkPattern(0,1,1,0,1,0,1)
  WorkPattern(0,1,1,0,1,0,0)
  WorkPattern(1,0,0,1,0,1,1)
  WorkPattern(0,1,1,0,0,1,0)
  WorkPattern(1,0,0,1,1,0,1)
  WorkPattern(0,1,0,1,1,0,0)
  Sleep, BreakDelay
  WorkPattern(1,0,1,0,0,1,1)
}
Else If (Color1=3 && Color2=1 && Color3=1 && Color4=1 && Color5=1 && Color6=0 && Color7=0)
{
  ;Triple (5 color)
  ;Breaks six stones

  WorkPattern(1,0,0,1,1,0,0)
  WorkPattern(0,1,0,1,0,1,0)
  WorkPattern(1,0,0,1,0,1,0)
  WorkPattern(0,1,0,1,0,0,1)
  WorkPattern(1,0,0,1,0,0,1)
  WorkPattern(0,1,0,0,1,1,0)
  WorkPattern(1,0,0,0,1,1,0)
  WorkPattern(0,1,0,0,1,0,1)
  WorkPattern(1,0,0,0,1,0,1)
  WorkPattern(0,1,0,0,0,1,1)
  WorkPattern(1,0,0,0,0,1,1)
  WorkPattern(0,1,0,1,1,0,0)
  Sleep, 50
  WorkPattern(1,1,1,0,0,0,0)
  Sleep, BreakDelay
  WorkPattern(0,0,1,1,1,1,1)
}
Else If (Color1=4 && Color2=1 && Color3=1 && Color4=1 && Color5=0 && Color6=0 && Color7=0)
{
  ;Quadriple (four color)
  ;Possible to break six stones

  WorkPattern(0,0,1,0,1,0,1)
  WorkPattern(1,0,0,0,1,1,0)
  WorkPattern(0,1,0,0,1,0,1)
  WorkPattern(1,0,0,0,1,0,1)
  WorkPattern(0,0,1,0,1,1,0)
  WorkPattern(1,0,0,0,0,1,1)
  WorkPattern(0,1,0,0,1,1,0)
  WorkPattern(1,1,1,0,0,0,0)
  WorkPattern(0,1,0,0,0,1,1)
  WorkPattern(1,1,0,1,0,0,0)
  WorkPattern(0,0,1,0,0,1,1)
  WorkPattern(1,0,1,1,0,0,0)
  WorkPattern(0,0,0,1,1,1,1)
  Sleep, BreakDelay
  WorkPattern(0,1,1,1,0,0,0)
  WorkPattern(1,1,1,1,0,0,0)
}
Else If (Color1=5 && Color2=1 && Color3=1 && Color4=0 && Color5=0 && Color6=0 && Color7=0)
{
  ;Quintuple
  ;Breaks five stones

  WorkPattern(1,1,1,0,0,0,0)
  WorkPattern(1,1,0,1,0,0,0)
  WorkPattern(1,1,0,0,1,0,0)
  WorkPattern(1,0,1,1,0,0,0)
  WorkPattern(1,0,1,0,1,0,0)
  WorkPattern(1,0,0,1,1,0,0)
  WorkPattern(0,1,1,1,0,0,0)
  WorkPattern(0,1,1,0,1,0,0)
  WorkPattern(0,1,0,1,1,0,0)
  WorkPattern(0,0,1,1,1,0,0)
  WorkPattern(1,1,1,1,1,0,0)
}
Else If (Color1=3 && Color2=2 && Color3=1 && Color4=1 && Color5=0 && Color6=0 && Color7=0)
{
  ;Triple and pair (4 color)
  ;Possible to break four stones

  WorkPattern(1,1,1,0,0,0,0)
  Sleep, 100
  WorkPattern(0,0,1,1,0,1,0)
  WorkPattern(1,0,0,1,0,1,0)
  WorkPattern(0,1,0,1,0,0,1)
  WorkPattern(1,0,0,0,1,1,0)
  WorkPattern(0,0,1,1,0,0,1)
  WorkPattern(1,0,0,1,0,0,1)
  WorkPattern(0,1,0,0,0,1,1)
  WorkPattern(1,0,0,0,1,0,1)
  Sleep, 200
  WorkPattern(1,0,0,0,0,1,1)
  WorkPattern(0,1,0,1,0,1,0)
  WorkPattern(1,0,0,1,0,1,1)
}
Else If (Color1=4 && Color2=2 && Color3=1 && Color4=0 && Color5=0 && Color6=0 && Color7=0)
{
  ;Quad and pair (3 color)
  ;Single stone breaks

  WorkPattern(1,0,0,0,1,0,1)
  WorkPattern(1,0,0,0,0,1,1)
  WorkPattern(0,1,0,0,1,0,1)
  WorkPattern(0,1,0,0,0,1,1)
  WorkPattern(0,0,1,0,1,0,1)
  WorkPattern(0,0,1,0,0,1,1)
  WorkPattern(0,0,0,1,1,0,1)
}
Else If (Color1=4 && Color2=3 && Color3=0 && Color4=0 && Color5=0 && Color6=0 && Color7=0)
{
  ;Quad and triple (two colors)
  ;No stones can be broken
  ;Works stones to speed up resetting the mine

  WorkPattern(1,1,1,0,0,0,0)
  WorkPattern(1,1,0,1,0,0,0)
  WorkPattern(0,1,1,1,0,0,0)
  WorkPattern(1,1,1,1,0,0,0)
  WorkPattern(0,0,0,0,1,1,1)
}
Else If (Color1=3 && Color2=3 && Color3=1 && Color4=0 && Color5=0 && Color6=0 && Color7=0)
{
  ;Two triples (three colors)
  ;Can break only one stone

  WorkPattern(1,0,0,1,0,0,1)
  WorkPattern(1,0,0,0,1,0,1)
  WorkPattern(1,0,0,0,0,1,1)
  WorkPattern(0,1,0,1,0,0,1)
  WorkPattern(0,1,0,0,1,0,1)
  WorkPattern(0,1,0,0,0,1,1)
  WorkPattern(0,0,1,1,0,0,1)

  ;Can work these two as well. But why?
  ;WorkPattern(1,1,1,0,0,0,0)
  ;WorkPattern(0,0,0,1,1,1,0)
}
Else If (Color1=3 && Color2=2 && Color3=2 && Color4=0 && Color5=0 && Color6=0 && Color7=0)
{
  ;Triple and two pairs (3 colors)
  ;No stones can be broken
  ;Work loads to speed up mine reset

  WorkPattern(1,0,0,1,0,1,0)
  WorkPattern(1,0,0,1,0,0,1)
  WorkPattern(1,0,0,0,1,1,0)
  WorkPattern(1,0,0,0,1,0,1)
  WorkPattern(0,1,0,1,0,1,0)
  WorkPattern(0,1,0,1,0,0,1)
  WorkPattern(0,1,0,0,1,1,0)
  WorkPattern(0,1,0,0,1,0,1)

  ;Can work more if needed
  ;WorkPattern(0,0,1,1,0,1,0)
  ;WorkPattern(0,0,1,1,0,0,1)
  ;WorkPattern(0,0,1,0,1,1,0)
  ;WorkPattern(0,0,1,0,1,0,1)
}
Else
{
  MsgBox, Unknown Configuration: %Color1% %Color2% %Color3% %Color4% %Color5% %Color6% %Color7%
  return
}

If (MineSet = 1)
{
  MouseMove, MineX, MineY
}

Color1:=0
Color2:=0
Color3:=0
Color4:=0
Color5:=0
Color6:=0
Color7:=0
Stones:=0

Sleep, BreakDelay
Send, w

BlockInput, MouseMoveOff
return


WorkPattern(Stone1, Stone2, Stone3, Stone4, Stone5, Stone6, Stone7)
{
  global StoneX1, StoneX2, StoneX3, StoneX4, StoneX5, StoneX6, StoneX7
  global StoneY1, StoneY2, StoneY3, StoneY4, StoneY5, StoneY6, StoneY7
  global DefaultDelay
  global PopupDelay
  global ConsecutiveRuns
  WinGetActiveStats, WindowTitle, WindowWidth, WindowHeight, WinPosX, WinPosY

  Loop
  {
    ImageSearch, FoundX, FoundY, WindowWidth/2 - 50, WindowHeight/2 - 50, WindowWidth/2 + 50, WindowHeight/2 + 200, *70 ok2.png
    If ErrorLevel = 0
    {
      If AdjustSpeed = 1
      {
        ImageSearch, , , WindowWidth/2-200, WindowHeight/2-60, WindowWidth/2+200, WindowHeight/2+30, *70 orestone_busy.png
        If ErrorLevel = 0
        {
          DefaultDelay:=ceil(DefaultDelay*1.1)
          ConsecutiveRuns:=0
        }
      }
      RightClickInstant(FoundX, FoundY)
      Sleep, PopupDelay
    }
    else
      break
  }


  If AdjustSpeed = 1
  {
    If (ConsecutiveRuns++ >= 10)
    {
      DefaultDelay:=ceil(DefaultDelay*0.95)
      ConsecutiveRuns:=0
    }
  }

  last:=7
  Loop, 7
  {
    If Stone%last% = 1
      break
    last--
  }

  i:=0
  Loop, 7
  {
    i++

    If (Stone%i%=1)
    {
      MouseMove, StoneX%i%, StoneY%i%
      Sleep, DefaultDelay
      If i = last
        break
      Send, a
      Sleep, DefaultDelay/5
    }
  }
  Send, s
  Sleep, PopupDelay
  return
}

RightClickInstant(X,Y)
{
  PostMessage, 0x0204, 0, X + (Y<<16), , A
  PostMessage, 0x0205, 0, X + (Y<<16), , A
}

LeftClickInstant(X,Y)
{
  PostMessage, 0x0201, 0, X + (Y<<16), , A
  PostMessage, 0x0202, 0, X + (Y<<16), , A
}

^+!r::Reload
^+!`::Pause
^+!e::Edit